// SPDX-License-Identifier: Zlib
/* ------------------------------------------------------------------------- */
/*!
 *  \file       mgl_ui_event_default_delegate.h
 *  \brief      MGL UIイベントのデフォルトデリゲート
 *  \date       Since: July 14, 2023. 16:29:29 JST.
 *  \author     Acerola
 */
/* ------------------------------------------------------------------------- */

#ifndef INCGUARD_MGL_UI_EVENT_DEFAULT_DELEGATE_H_1689319769
#define INCGUARD_MGL_UI_EVENT_DEFAULT_DELEGATE_H_1689319769

#include <mgl/ui/mgl_ui_event_delegate.h>

namespace MGL::UI
{
class DefaultEventDelegate : public EventDelegate
{
public:
    virtual ~DefaultEventDelegate() noexcept = default;
    
    virtual EventResult OnUpdateUIEvent(const MGL::STL::vector<EventTarget> &targets, EventIdentifier currentFocusID) noexcept override;

    static EventResult Update(const MGL::STL::vector<EventTarget> &targets, EventIdentifier currentFocusID) noexcept;

private:
    static EventResult UpdateMouseEvent(const MGL::STL::vector<EventTarget> &targets) noexcept;
    static EventResult UpdateTouchEvent(const MGL::STL::vector<EventTarget> &targets, EventIdentifier currentFocusID) noexcept;
};
}   // namespace MGL::UI

#endif	// INCGUARD_MGL_UI_EVENT_DEFAULT_DELEGATE_H_1689319769

// vim: et ts=4 sw=4 sts=4
